<?php
if(!defined('IN_DISCUZ')) {
    exit('Access Denied');
}

$_G['siteurl']=trim(str_replace('/source/plugin/skycaiji2discuz', '', $_G['siteurl']),'/').'/';
$_G['scj_img_pattern']='/(?P<i1>\[img[^\[\]]*\])(?P<i2>[^\[\]]+?)(?P<i3>\[\/img\])/i';

ob_clean();//清除输出
ob_start();//缓存输出


require_once 'skycaiji2cms/skycaiji2cms.php';
$scj2cms=new skycaiji2cms(
    DISCUZ_ROOT.'source/plugin/skycaiji2discuz/',
    $_G['siteurl'].'source/plugin/skycaiji2discuz/',
    $_G['charset'],
    false
);

$scj2cms->pluginConfig=$_G['cache']['plugin']['skycaiji2discuz'];//插件配置
$scj2cms->pluginLang=lang('plugin/skycaiji2discuz');//指定语言包
function funcGetPost($key){
    return $_GET[$key];
}
$scj2cms->funcGetPost='funcGetPost';

function getParamLang($key,$isThread=true){
    global $scj2cms;
    return $scj2cms->pluginLang['api_'.($isThread?'data':'art').'_'.$key];
}

$isClosed=false;
if(!in_array('skycaiji2discuz',$_G['setting']['plugins']['available'])){
    $isClosed=true;
}

$module=$_GET['module'];

$isThread=stripos($module,'thread')!==false?true:false;
if(!$scj2cms->isPost()){
    //get模式,返回插件信息
    if($isClosed){
        $scj2cms->returnData(0,lang('plugin/skycaiji2discuz','closed'));
    }
    $error=$scj2cms->checkKeyError();//验证密钥
    if($error){
        $scj2cms->returnData(0,$error);
    }
    if(!$isThread){
        //文章
        loadcache('portalcategory');
        $category=$_G['cache']['portalcategory'];
        $cats=array();
        foreach ($category as $cat){
            if($cat['level']==0) {
                $cats[$cat['catid']]=$cat['catname'];
                if($cat['children']){
                    foreach ($cat['children'] as $catid) {
                        $cats[$category[$catid]['catid']]='--'.$category[$catid]['catname'];
                        if($category[$catid]['children']) {
                            foreach ($category[$catid]['children'] as $catid2) {
                                $cats[$category[$catid2]['catid']]='----'.$category[$catid2]['catname'];
                            }
                        }
                    }
                }
            }
        }
        $formRequired=array(
            'catid'=>array(
                'tag'=>'select',
                'option'=>$cats
            ),
            'title'=>null,
            'content'=>null,
        );//必填
        
            
        //必填项
        $scj2cms->formRequired=array();
        foreach ($formRequired as $k=>$v){
            $v=is_array($v)?$v:array();
            if(empty($v['name'])){
                $v['name']=getParamLang($k,$isThread);
            }
            $scj2cms->formRequired[$k]=$v;
        }
    }else{
        //帖子
        loadcache('forums');
        loadcache('groupreadaccess');
        $fids=array();
        foreach ($_G['cache']['forums'] as $k=>$v){
            if($v['type']=='forum'||$v['type']=='sub'){
                $fids[$k]=($v['type']=='sub'?str_repeat('-',4):'').$v['name'];
            }
        }
        
        $formRequired=array(
            'fid'=>array(
                'tag'=>'select',
                'option'=>$fids,
            ),
            'subject'=>null,
            'message'=>null,
        );//必填
        
        //必填项
        $scj2cms->formRequired=array();
        foreach ($formRequired as $k=>$v){
            $v=is_array($v)?$v:array();
            if(empty($v['name'])){
                $v['name']=getParamLang($k,$isThread);
            }
            $scj2cms->formRequired[$k]=$v;
        }
    }
    
    $scj2cms->returnApi();
}else{
    if($isClosed) {
        $scj2cms->returnResult(0,lang('plugin/skycaiji2discuz','closed'));
    }
    
    if(!$isThread){
        //文章
        //终止函数
        function pluginExitDo(){
            global $_G,$scj2cms;
            $html=ob_get_contents();//获取输出
            $html=trim($html);
            ob_clean();//清理页面
            
            if(!empty($html)){
                if(strpos($html, '{')===0){
                    //是json
                    exit($html);
                }else{
                    $data=array(
                        'id'=>'',
                        'target'=>'',
                        'desc'=>'',
                        'error'=>'',
                    );
                    //获取错误信息
                    if(preg_match('/errorhandle_\(\'(.+?)\'/',$html,$error)){
                        $data['error']=strip_tags($error[1]);
                    }elseif(preg_match('/<div[^<>]*?id\s*=[\'\"]messagetext[\'\"][^<>]*?>[\s\r\n]*<p[^<>]*>([\s\S]+?)<\/p>/',$html,$error)){
                        $data['error']=strip_tags($error[1]);
                    }
                    if(empty($data['error'])){
                        if(preg_match('/portal\.php\?mod=portalcp\&ac=article\&catid=\d+\&op=edit\&aid=(\d+)/i',$html,$aid)){
                            //发布成功
                            $aid=$aid[1];
                            $data['id']=$aid;
                            $data['target']=$_G['siteurl'].'portal.php?mod=view&aid='.$aid;
                        }
                    }
                    if($data['id']||$data['error']){
                        $scj2cms->returnResult($data['id'],$data['error'],$data['target'],$data['desc']);
                    }else{
                        //直接输入html
                        exit($html);
                    }
                }
            }
            $scj2cms->returnResult(0,'failed');
        }
        register_shutdown_function('pluginExitDo');
        
        //发布函数
        function funcApiPost(){
            global $_G,$scj2cms;
            //json数据
            $json=$scj2cms->jsonPostData();
            foreach ($json as $k=>$v){
                $_GET[$k]=$_POST[$k]=$v;
            }
            //文章数据
            if(empty($_GET['title'])){
                $scj2cms->returnResult(0,lang('plugin/skycaiji2discuz','error_art_title'));
            }
            if(empty($_GET['content'])){
                $scj2cms->returnResult(0,lang('plugin/skycaiji2discuz','error_art_content'));
            }
            //分类
            $catid=$_GET['catid'];
            loadcache('portalcategory');
            $portalcategory = $_G['cache']['portalcategory'];
            $existCat=false;
            if($catid&&!empty($portalcategory)){
                foreach ($portalcategory as $k=>$v){
                    if($v['catid']==$catid){
                        $existCat=true;
                        break;
                    }
                }
            }
            $catid=$existCat?$catid:0;
            if($catid<=0){
                $scj2cms->returnResult(0,lang('plugin/skycaiji2discuz','error_art_catid'));
            }
            $_GET['catid']=$_POST['catid']=$catid;
            
            $author=$scj2cms->randLine($scj2cms->pluginConfig['author']);
            if(empty($author)){
                $scj2cms->returnResult(0,lang('plugin/skycaiji2discuz','error_author'));
            }
            //加载用户
            require_once DISCUZ_ROOT.'./source/function/function_magic.php';
            require_once DISCUZ_ROOT.'./source/function/function_editor.php';
            $member=getuserinfo($author);
            if(empty($member)){
                $scj2cms->returnResult(0,lang('plugin/skycaiji2discuz','error_author').':'.$author);
            }
            //标签
            if(is_array($_GET['tag'])){
                $tags=array();
                foreach ($_GET['tag'] as $v){
                    $tags[$v]='on';
                }
                $_GET['tag']=$_POST['tag']=$tags;
            }
            $_G['uid'] = intval($member['uid']);
            $_G['username'] = $member['username'];
            $_G['adminid'] = $member['adminid'];
            $_G['groupid'] = $member['groupid'];
            $_G['formhash'] = formhash();
            $_G['session']['invisible'] = getuserprofile('invisible');
            $_G['member'] = $member;
            loadcache('usergroup_'.$_G['groupid']);
            
            //设置封面
            $coverUrl=$_GET['cover_url']?:$scj2cms->get_first_img($_GET['content']);
            if($coverUrl){
               
            }
            //发帖参数
            $_GET['ac'] = 'article';
            $_GET['op']='add';
            $_GET['articlesubmit']=true;
            $_GET['formhash']=formhash();
            
            //function submitcheck验证
            $_G['group']['seccode']=0;//关闭验证码
            $_G['group']['disablepostctrl']=1;//取消发帖间隔
            
            $_SERVER['REQUEST_METHOD']='POST';
            $_SERVER['HTTP_REFERER']=$_G['siteurl'].'portal.php';
            //showmessage设置
            $_G['inajax']=1;//防止showmessage header跳转
            
            require_once DISCUZ_ROOT.'./source/function/function_portal.php';
            require_once DISCUZ_ROOT.'./source/function/function_home.php';
            require_once DISCUZ_ROOT.'./source/module/portal/portal_portalcp.php';
        }
        $scj2cms->funcApiPost='funcApiPost';
        $scj2cms->apiPost();
    }else{
        //帖子
        //终止函数
        function pluginExitDo(){
            global $_G,$scj2cms;
            $html=ob_get_contents();//获取输出
            $html=trim($html);
            ob_clean();//清理页面
            if(!empty($html)){
                if(strpos($html, '{')===0){
                    //是json
                    exit($html);
                }else{
                    $data=array(
                        'id'=>'',
                        'target'=>'',
                        'desc'=>'',
                        'error'=>'',
                    );
                    //获取错误信息
                    if(preg_match('/errorhandle_\(\'(.+?)\'/',$html,$error)){
                        $data['error']=strip_tags($error[1]);
                    }elseif(preg_match('/<div[^<>]*?id\s*=[\'\"]messagetext[\'\"][^<>]*?>[\s\r\n]*<p[^<>]*>([\s\S]+?)<\/p>/',$html,$error)){
                        $data['error']=strip_tags($error[1]);
                    }
                    if(empty($data['error'])){
                        if(preg_match('/succeedhandle_\(\'(.+?)\'/',$html,$target)){
                            //发布成功
                            $data['target']=$_G['siteurl'].trim($target[1]);
                            if(preg_match('/\'tid\':\'(\d+)\'/',$html,$tid)){
                                //tid
                                $tid=$tid[1];
                                $data['id']=$tid;
                            }elseif(preg_match('/action=newthread\&fid=\d+\&sortid=\d+\'\s*\,\s*\'([^\'\"]+)/',$html,$merror)){
                                //分类信息错误提示
                                $data['error']=strip_tags($merror[1]);
                                $data['target']='';
                            }
                        }
                    }
                    
                    if($data['id']||$data['error']){
                        $scj2cms->returnResult($data['id'],$data['error'],$data['target'],$data['desc']);
                    }else{
                        //直接输入html
                        exit($html); 
                    }
                }
            }
            $scj2cms->returnResult(0,'failed');
        }
        register_shutdown_function('pluginExitDo');
        //发布函数
        function funcApiPost(){
            global $_G,$scj2cms;
            //json数据
            $json=$scj2cms->jsonPostData();
            foreach ($json as $k=>$v){
                $_GET[$k]=$v;
            }
            //帖子数据
            $fid=intval($_GET['fid']);
            if($fid<=0){
                $scj2cms->returnResult(0,lang('plugin/skycaiji2discuz','error_fid'));
            }
            if(empty($_GET['subject'])){
                $scj2cms->returnResult(0,lang('plugin/skycaiji2discuz','error_subject'));
            }
            if(empty($_GET['message'])){
                $scj2cms->returnResult(0,lang('plugin/skycaiji2discuz','error_message'));
            }
            $author=$scj2cms->randLine($scj2cms->pluginConfig['author']);
            if(empty($author)){
                $scj2cms->returnResult(0,lang('plugin/skycaiji2discuz','error_author'));
            }
            //加载用户
            require_once DISCUZ_ROOT.'./source/function/function_magic.php';
            require_once DISCUZ_ROOT.'./source/function/function_editor.php';
            $member=getuserinfo($author);
            if(empty($member)){
                $scj2cms->returnResult(0,lang('plugin/skycaiji2discuz','error_author').':'.$author);
            }
            
            $_G['uid'] = intval($member['uid']);
            $_G['username'] = $member['username'];
            $_G['adminid'] = $member['adminid'];
            $_G['groupid'] = $member['groupid'];
            $_G['formhash'] = formhash();
            $_G['session']['invisible'] = getuserprofile('invisible');
            $_G['member'] = $member;
            loadcache('usergroup_'.$_G['groupid']);
            
            //发帖参数
            $_GET['action'] = 'newthread';
            $_GET['extra']='';
            $_GET['topicsubmit']='yes';
            $_GET['formhash']=formhash();
            
            //默认参数
            $defParams=array('replycredit_times'=>1,'replycredit_membertimes'=>1,'replycredit_random'=>100,'allownoticeauthor'=>1,'usesig'=>1,'allowimgcode'=>1,'allowimgurl'=>1);
            foreach ($defParams as $k=>$v){
                if(!isset($_GET[$k])){
                    $_GET[$k]=$v;
                }
            }
            
            //function submitcheck验证
            $_G['group']['seccode']=0;//关闭验证码
            $_G['group']['disablepostctrl']=1;//取消发帖间隔
            
            $_SERVER['REQUEST_METHOD']='POST';
            $_SERVER['HTTP_REFERER']=$_G['siteurl'].'forum.php?mod=post&action=newthread&fid='.$fid;
            //showmessage设置
            $_G['inajax']=1;//防止showmessage header跳转
            
            require_once DISCUZ_ROOT.'./source/function/function_forum.php';
            loadforum($fid);//载入板块
            
            if($_G['forum']['allowhtml']){
                $_GET['htmlon']=1;//HTML 代码
            }elseif($_G['forum']['allowbbcode']){
                $_GET['message']=html2bbcode($_GET['message']);//转换成dz格式
                $_GET['message']=preg_replace_callback($_G['scj_img_pattern'], function($match){
                    return $match['i1'].htmlspecialchars_decode($match['i2']).$match['i3'];//防止&被编码
                }, $_GET['message']);
            }
            
            require_once DISCUZ_ROOT.'./source/module/forum/forum_post.php';
        }
        $scj2cms->funcApiPost='funcApiPost';
        $scj2cms->apiPost();
    }
}

    		  	  		  	  		     	  	 			    		   		     		       	   	 		    		   		     		       	   	 		    		   		     		       	   				    		   		     		       	   	 	    		   		     		       	 	        		   		     		       	 	        		   		     		       	  	  		    		   		     		       	  	        		   		     		       	  			      		   		     		       	  				     		   		     		       	  	  		    		   		     		       	  	 			    		   		     		       	  	        		   		     		       	   		      		   		     		       	   	 		    		   		     		       	 	        		   		     		       	  		 		    		   		     		       	    	 	    		   		     		       	  		      		   		     		       	  	 		    		   		     		       	 	        		 	      	  		  	  		     	