<?php
if(!defined('IN_DISCUZ')) {
    exit('Access Denied');
}
//版本:2.2
define('in_skycaiji2cms', 1);//权限
include 'head.php';
class skycaiji2cms{
    public $charset;//编码
    
    public $pluginPath;//插件根目录
    public $pluginUrl;//插件根网址
    public $pluginConfig;//插件配置
    public $pluginConfigFile='plugin_config.php';//插件配置文件名
    
    public $funcError;//报错函数
    public $funcFormPost;//表单提交函数
    public $funcApiPost;//接口提交函数
    public $funcGetPost;//获取$_POST参数函数
    
    public $openForm;//是否使用表单设置
    public $formHeadHtml;//表单头部html
    public $formFootHtml;//表单尾部html
    public $formUrl='';//form表单地址
    public $formRequired;//表单必填项
    public $formOptional;//表单选填项
    
    public $apiUrl;//接口地址
    public $bodyEndHtml;//结束html
    
    public $pluginLang;//语言包，不同编码
    
    public $static;//静态资源
    
    public $imgPattern='/(?P<i1><img\b[^<>]*\bsrc\s*=\s*[\'\"])(?P<i2>[^\'\"\<\>]+?)(?P<i3>[\'\"])/i';//匹配图片
    public $imgPatternFull='/(?P<i1><img\b[^<>]*\bsrc\s*=\s*[\'\"])(?P<i2>[^\'\"\<\>]+?)(?P<i3>[\'\"][^<>]*?>)/i';//匹配完整图片
    
    //初始化
    public function __construct($pluginPath,$pluginUrl,$charset='utf-8',$openForm=false){
        $this->pluginPath=rtrim($pluginPath,'/\\').DIRECTORY_SEPARATOR;
        $this->pluginUrl=rtrim($pluginUrl,'/\\').'/';
        $this->openForm=$openForm?true:false;
        
        $this->charset=strtolower($charset);
        
        $langFile=$this->pluginPath.'skycaiji2cms/lang.php';
        if(file_exists($langFile)){
            $this->pluginLang=include $langFile;
        }
        
        $this->static=array(
            'css'=>$this->pluginUrl.'skycaiji2cms/css.css'
        );
        $this->loadPluginConfig();
    }
    //是post提交
    public function isPost(){
        if(strtolower($_SERVER['REQUEST_METHOD'])=='post'){
            return true;
        }else{
            return false;
        }
    }
    //是get接口
    public function isGetApi(){
        if(!$this->isPost()){
            //get模式
            $error=$this->checkKeyError();//验证密钥
            if($error){
                $this->returnData(0,$error);
            }
            return true;
        }else{
            return false;
        }
    }
    //表单是post提交
    public function formIsPost(){
        $sub=$this->doGetPost('formsub');
        if(!empty($sub)){
            return true;
        }else{
            return false;
        }
    }
    //表单提交
    public function formPost(){
        $data=array(
            'apikey'=>$this->doGetPost('apikey'),
            'author'=>$this->doGetPost('author'),
            'apitype'=>$this->doGetPost('apitype')
        );
        if(empty($data['author'])){
            $this->doError($this->pluginLang['empty_author']);
        }
        if(empty($data['apikey'])){
            $this->doError($this->pluginLang['empty_apikey']);
        }
        $this->doFormPost($data);
    }
    //表单html页面
    public function formView(){
        $scj2cms=$this;
        include $this->pluginPath.'skycaiji2cms/form.php';
    }
    //验证密钥
    public function checkKeyError(){
        $error='';
        if(empty($this->pluginConfig['apikey'])){
            $error=$this->pluginLang['empty_apikey'];
        }
        if($_GET['apikey']!=md5(sha1($this->pluginConfig['apikey']))){
            $error=$this->pluginLang['error_apikey'];
        }
        return $error;
    }
    //接口提交
    public function apiPost(){
        if(!$this->isPost()){
            $this->returnResult(0,$this->pluginLang['error_request']);
        }
        if(empty($this->pluginConfig)){
            $this->returnResult(0,$this->pluginLang['empty_plugin_config']);
        }
        if(empty($this->pluginConfig['author'])){
            $this->returnResult(0,$this->pluginLang['empty_author']);
        }
        if(empty($this->pluginConfig['apitype'])){
            //普通
            $error=$this->checkKeyError();
            if($error){
                $this->returnResult(0,$error);
            }
        }elseif($this->pluginConfig['apitype']=='safe'){
            //安全
            if(empty($this->pluginConfig['apikey'])){
                $this->returnResult(0,$this->pluginLang['empty_apikey']);
            }
            $apiTime=$_GET['apitime'];
            $apiTime=intval($apiTime);
            $apiSign=$_GET['apisign'];
            if($apiSign!=md5($apiTime.$this->pluginConfig['apikey'])){
                $this->returnResult(0,$this->pluginLang['error_apisign']);
            }elseif(time()-$apiTime>600){
                $this->returnResult(0,$this->pluginLang['error_timeout'].date('Y-m-d H:i:s',$apiTime));
            }
        }else{
            $this->returnResult(0,$this->pluginLang['error_apitype']);
        }
        
        $this->doApiPost();
    }
    //返回入库结果
    public function returnResult($id,$error='',$target='',$desc=''){
        $data=array(
            'id'=>$id?$id:0,
            'target'=>$target,
            'desc'=>$desc,
            'error'=>$error,
        );
        if($data['error']){
            $data['error']=$this->pluginLang['error_return'].$data['error'];
        }
        $this->_json($data);
    }
    //返回数据
    public function returnData($code,$msg,$data=null){
        $data=array(
            'code'=>$code,
            'msg'=>$msg,
            'data'=>$data
        );
        $this->_json($data);
    }
    //返回api数据
    public function returnApi(){
        $data=array(
            'type'=>'post',
            'charset'=>$this->charset,
            'content_type'=>'application/json',
            'response'=>array(
                'id'=>'id',
                'target'=>'target',
                'desc'=>'desc',
                'error'=>'error',
            )
        );
        $params=array();
        if(is_array($this->formRequired)){
            foreach ($this->formRequired as $k=>$v){
                $v=is_array($v)?$v:array('name'=>$v);//默认字符串是名称
                $v['required']=1;
                $params[$k]=$v;
            }
        }
        if(is_array($this->formOptional)){
            foreach ($this->formOptional as $k=>$v){
                $v=is_array($v)?$v:array('name'=>$v);//默认字符串是名称
                $v['required']=0;
                $params[$k]=$v;
            }
        }
        $data['params']=$params;
        $this->returnData(1,'',$data);
    }
    
    //随机一行
    public function randLine($str){
        $list=array();
        if($str&&preg_match_all('/[^\r\n]+/',$str,$list)){
            $list=$list[0];
            $list=array_filter($list);
            $list=array_values($list);
        }else{
            $list=array();
        }
        $rand=array_rand($list,1);
        $rand=$list[$rand];
        return $rand;
    }
    //判断是网址
    public function isUrl($url){
        if($url&&preg_match('/^\w+\:\/\/[^\r\n]+/',$url)){
            return true;
        }else{
            return false;
        }
    }
    //获取代码
    public function get_html($url){
        $html='';
        if(function_exists('curl_init')){
            $data=$this->curl($url);
            if($data&&$data['body']){
                $html=$data['body'];
            }
        }else{
            $html=file_get_contents($url);
        }
        return $html;
    }
    //获取头信息
    public function get_header($url){
        $header='';
        if(function_exists('curl_init')){
            $data=$this->curl($url,array(),array('nobody'=>1));
            if($data&&$data['header']){
                $header=$data['header'];
            }
        }else{
            $header=get_headers($url);
            $header=$header?implode("\r\n",$header):'';
        }
        return $header;
    }
    //获取图片类型
    public function get_img_type($url){
        $header=$this->get_header($url);
        $type='';
        if(preg_match('/\bcontent-type\s*\:\s*image\s*\/(\w+)/i',$header,$type)){
            $type=strtolower($type[1]);
        }else{
            $type='';
        }
        return $type;
    }
    //获取第一张图片
    public function get_first_img($html){
        if($html&&preg_match('/<img[^<>]*\bsrc\s*=[\'\"]([^<>\'\"]+)[\'\"]/i', $html,$img)){
            return $img[1];
        }else{
            return '';
        }
    }
    
    public function curl($url,$headers=array(),$options=array(),$postData=null){
        $headers=is_array($headers)?$headers:array();
        $options=is_array($options)?$options:array();
        
        $options['timeout']=intval($options['timeout']);
        $options['timeout']=$options['timeout']>0?$options['timeout']:20;//连接超时
        
        $ch = curl_init ();
        curl_setopt ( $ch, CURLOPT_URL, $url );
        curl_setopt ( $ch, CURLOPT_TIMEOUT, $options['timeout'] );
        curl_setopt ( $ch, CURLOPT_CONNECTTIMEOUT , 10 );//响应超时
        curl_setopt ( $ch, CURLOPT_RETURNTRANSFER, 1 );
        curl_setopt ( $ch, CURLOPT_FOLLOWLOCATION, 1 );
        curl_setopt ( $ch, CURLOPT_HEADER, 1 );
        curl_setopt ( $ch, CURLOPT_ENCODING , '');//自动解码
        if($options['nobody']){
            //不返回正文
            curl_setopt($ch, CURLOPT_NOBODY, true);
        }
        if($options['useragent']){
            //浏览器标识
            curl_setopt($ch, CURLOPT_USERAGENT, $options['useragent']);
        }
        //忽略https模式
        curl_setopt ( $ch, CURLOPT_SSL_VERIFYPEER, FALSE );
        curl_setopt ( $ch, CURLOPT_SSL_VERIFYHOST, FALSE );
        //设置头信息
        if(!empty($headers)&&count($headers)>0){
            curl_setopt ( $ch, CURLOPT_HTTPHEADER, $headers );
        }
        
        if(isset($postData)&&$postData!==false){
            //不是null和false是post模式
            curl_setopt ( $ch, CURLOPT_POST, 1 );
            if(is_array($postData)){
                //必须转成url字符串才是网页表单类型application/x-www-form-urlencoded
                $postData=http_build_query($postData);
            }
            curl_setopt ( $ch, CURLOPT_POSTFIELDS, $postData );
        }
        
        $body = curl_exec ( $ch );
        
        $headerPos=strpos($body, "\r\n\r\n");//头信息定位索引
        if($headerPos!==false){
            $headerPos=intval($headerPos)+strlen("\r\n\r\n");//加上换行的长度等于头大小
        }
        $headerSize = curl_getinfo($ch, CURLINFO_HEADER_SIZE);//头大小
        $headerSize=intval($headerSize);
        if($headerSize<$headerPos){
            $headerSize=$headerPos;
        }
        
        $header = substr($body, 0, $headerSize);//头信息
        $body = substr($body, $headerSize);//body内容
        
        $code=curl_getinfo($ch,CURLINFO_HTTP_CODE);//状态码
        $code=intval($code);
        curl_close ( $ch );
        
        $data=array('header'=>$header);
        if($body){
            $data['body']=$body;
        }
        return $data;
    }
    
    //运行错误
    protected function doError($msg){
        if($this->funcError){
            call_user_func($this->funcError, $msg);
            exit();
        }else{
            exit($msg);
        }
    }
    //运行formPost
    protected function doFormPost($data){
        call_user_func($this->funcFormPost, $data);
    }
    //运行apiPost
    protected function doApiPost(){
        if($this->funcApiPost){
            call_user_func($this->funcApiPost);
        }
    }
    //获取post参数
    protected function doGetPost($key){
        if(empty($this->funcGetPost)){
            return isset($_POST[$key])?$_POST[$key]:'';
        }else{
            return call_user_func($this->funcGetPost,$key);
        }
    }
    private function _json($data){
        ob_clean();
        if($this->charset!='utf-8'){
            $data=$this->convertCharset($data,$this->charset,'utf-8');
        }
        header('content-type:application/json;charset=utf-8');
        $data=json_encode($data);
        exit($data);
    }
    //转换编码
    public function convertCharset($data,$from,$to){
        if(is_array($data)){
            foreach ($data as $k=>$v){
                $data[$k]=$this->convertCharset($v,$from,$to);
            }
        }else{
            $data=iconv($from,$to.'//IGNORE',$data);
        }
        return $data;
    }
    //获取json类型post数据
    public function jsonPostData(){
        $json=file_get_contents('php://input');
        if($json){
            $json=json_decode($json,true);
        }
        if(!is_array($json)){
            $json=array();
        }
        $json=$this->convertCharset($json,'utf-8',$this->charset);
        return $json;
    }
    //载入post的json数据
    public function loadJsonPostData(){
        $json=$this->jsonPostData();
        foreach ($json as $k=>$v){
            $_POST[$k]=$v;
        }
    }
    //初始化数组
    public function initArray(&$data){
        if(!is_array($data)){
            $data=array();
        }
    }
    //递归创建目录
    public function mkDir($fileName,$index=true){
        $dirs=array();
        $dir=$fileName;
        while($dir){
            $dir=dirname($dir);
            if($dir&&preg_match('/[\w\_\-]+$/', $dir)){
                //是正常结尾
                $dirs[]=$dir;
            }else{
                $dir='';
            }
        }
        $success=true;//默认成功
        if($dirs){
            $dirIx=-1;
            for($i=count($dirs)-1;$i>=0;$i--){
                if(@is_dir($dirs[$i])){
                    //判断可读的目录索引，因为受到open_basedir影响会导致目录外不可读
                    $dirIx=$i;
                    break;
                }
            }
            if($dirIx>=0){
                for($i=$dirIx;$i>=0;$i--){
                    if(!is_dir($dirs[$i])){
                        @umask(0);
                        $res=mkdir($dirs[$i], 0777);
                        if ($res === false) {
                            //创建目录失败
                            $success=false;
                            break;
                        }else{
                            if($index){
                                //创建首页
                                if(!is_file($dirs[$i].'/index.html')){
                                    @touch($dirs[$i].'/index.html');
                                }
                            }
                        }
                    }
                }
            }
        }
        return $success;
    }
    //获取文件扩展名
    public function fileExt($fileName){
        return strtolower(pathinfo($fileName, PATHINFO_EXTENSION));
    }
    //保存文件
    public function fileSaveTo($fileName,$saveToName,$options=array(),$isImg=true){
        if(is_file($fileName)){
            $this->initArray($options);
            $fileExt=$this->fileExt($fileName);
            $this->initArray($options['allowExts']);
            $result=array('success'=>false,'msg'=>'');
            if($isImg&&empty($options['allowExts'])){
                $options['allowExts']=array('jpg','jpeg','gif','png','bmp','webp','wbmp');//默认
            }
            
            if(!empty($options['allowExts'])&&!in_array($fileExt,$options['allowExts'])){
                $result['msg']=$this->pluginLang['img_error_ext'];
                return $result;
            }else{
                if($options['maxSize']&&$options['maxSize']>0){
                    //限制大小
                    $fileSize=filesize($fileName);
                    if($fileSize>$options['maxSize']){
                        $result['msg']=$this->pluginLang['img_error_max_size'];
                        return $result;
                    }
                }
            }
            if(!$this->mkDir($saveToName)){
                $result['msg']=$this->pluginLang['img_error_dir'];
                return $result;
            }
            
            if($isImg&&($options['imgWidth']||$options['imgHeight'])){
                //裁剪图片
                $imgWidth=$options['imgWidth'];
                $imgHeight=$options['imgHeight'];
                $fileInfo=getimagesize($fileName);
                
                $noCreate=false;
                if($imgWidth<$fileInfo[0]){
                    //按比例缩放
                    $imgHeight=($imgWidth/$fileInfo[0])*$fileInfo[1];
                }else{
                    if($imgHeight<$fileInfo[1]){
                        //按比例缩放
                        $imgWidth=($imgHeight/$fileInfo[1])*$fileInfo[0];
                    }else{
                        //不用裁剪
                        $noCreate=true;
                    }
                }
                if($noCreate){
                    file_put_contents($saveToName, file_get_contents($fileName));
                }else{
                    $funcImage='image'.($fileExt=='jpg'?'jpeg':$fileExt);
                    $imgFile=imagecreatefromstring(file_get_contents($fileName));
                    if(function_exists('imagecreatetruecolor')){
                        $imgNew = imagecreatetruecolor($imgWidth, $imgHeight);
                    }else{
                        $imgNew = imagecreate($imgWidth, $imgHeight);
                    }
                    imagecopyresized($imgNew, $imgFile, 0, 0, 0, 0, $imgWidth, $imgHeight, $fileInfo[0], $fileInfo[1]);
                    call_user_func($funcImage,$imgNew,$saveToName);
                    ImageDestroy($imgNew);
                    ImageDestroy($imgFile);
                }
            }else{
                file_put_contents($saveToName, file_get_contents($fileName));
            }
            $result['success']=true;
        }
        return $result;
    }
    //保存文件
    public function saveFile($fileData,$saveName){
        $success=false;
        if($fileData&&$saveName){
            if($this->mkDir($saveName)){
                $success=file_put_contents($saveName, $fileData);
            }
        }
        return $success;
    }
    //保存图片网址为文件
    public function saveFileUrl($fileUrl,$fileName,$cache=true){
        static $list=array();
        $key=md5($fileUrl);
        if(empty($list[$key])){
            $fileData=$this->get_html($fileUrl);
            if($fileData&&$this->saveFile($fileData, $fileName)){
                $list[$key]=$fileName;
            }
        }
        $fileName=$list[$key]?:'';
        if(!$cache){
            //不缓存
            unset($list[$key]);
        }
        return $fileName;
    }
    //表单参数
    public function formParam($title,$name,$tag='',$default='',$options=null){
        $html='';
        if($tag=='radio'){
            $html='<label class="app-radio-inline"><input name="'.$name.'" type="radio" value="1" '.($default?' checked="checked"':'').'/> '.$this->pluginLang['param_radio_yes'].'</label><label class="app-radio-inline"><input name="'.$name.'" type="radio" value="0" '.($default?'':' checked="checked"').' /> '.$this->pluginLang['param_radio_no'].'</label>';
        }else{
            $html='<input name="'.$name.'" type="text" class="app-form-control" value="'.$default.'" />';
        }
        $html=<<<EOF
<div class="app-form-group">
    <div><label>{$title}</label></div>
    {$html}
</div>
EOF;
    return $html;
    }
    //载入配置
    public function loadPluginConfig(){
        $configFile=$this->pluginPath.$this->pluginConfigFile;
        if(file_exists($configFile)){
            try{
                include $configFile;
                if(!empty($pluginConfig)){
                    $pluginConfig=unserialize($pluginConfig);
                    $pluginConfig=is_array($pluginConfig)?$pluginConfig:array();
                    $this->pluginConfig=$pluginConfig;
                }
            }catch (\Exception $e){}
        }
        if(!is_array($this->pluginConfig)){
            $this->pluginConfig=array();
        }
    }
    //设置配置
    public function setPluginConfig($data){
        $data='<?php $pluginConfig="'.addslashes(serialize($data)).'";';
        $configFile=$this->pluginPath.$this->pluginConfigFile;
        if (!@file_put_contents($configFile, $data)) {
            $this->doError($configFile.$this->pluginLang['config_error_put']);
            return false;
        }else{
            return true;
        }
    }
}